/** 
 * @Version $Rev: 56 $
 * @Author M.Sekido
 * @Date  $Date: 2013-07-03 20:40:14 +0900 (Wed, 03 Jul 2013) $
 * $Id: Mk5B_mdl.cpp 56 2013-07-03 11:40:14Z vlbi $ 
 */

#include "Mk5B_mdl.hpp"

int Mk5B_Model::make_tab(unsigned char table[256]){
  int index;
  fprintf(stderr,"Bit encoding OffsetBin\n");
  memset(table,0,256);
  for(index=0;index<256;index++){
    if(index&0x80) table[index]|=0x40;
    if(index&0x40) table[index]|=0x80;
    if(index&0x20) table[index]|=0x10;
    if(index&0x10) table[index]|=0x20;
    if(index&0x08) table[index]|=0x04;
    if(index&0x04) table[index]|=0x08;
    if(index&0x02) table[index]|=0x01;
    if(index&0x01) table[index]|=0x02;
  }
  return 0;
}


int M5B_Model::Get_FirstData(const int32_t size_1sec){
  
  if(rfp ==0)  rfp = fopen(m5file.c_str(),"r");
  if(rfp ==0){
    cerr << "Error in Mk5B_Model::Get_FirstData(): Failed to open m5file(" 
	 << m5fname << ")\n";    return -1;  }
  if(size_1sec != das_info.Bytes_sec()){
    cerr << "Error at Mk5B_Model::Get_FirstData():";
    fprintf(stderr,"Reqst %ld B != DAS param(%ldsps %dbit %dch)=%ld Bytes.\n",
	    size_1sec, das_inf.Srate(),das_inf.Qbit(),das_inf.Nch(),
	    das_info.Bytes_sec());
    return -1;
  }
  int framesize = m5bhdr.Framesize();
  int headsize = m5bhdr.Headsize();
  int nframe = das_info.Bytes_sec()/(framesize-headsize);
  int bufsize = nframe*framesize;
  if(dat_buf.size() < bufsize) dat_buf.resize(bufsize);
  int first_1pp(0);
  Mk5B_Hdr *pmk5bh(0);
  //  uint8_t
  //  int32_t remain(0);

  remian=0;
  int nrd(0);

  while(first_1pp==0){
    pb= &dat_buf[0]+remain;
    nrd = fread(pb,bufsize-remain,1,rfp);
    if(nrd <1){
      cerr << "Error in Mk5B_Model::Get_FirstData(): Failed to fread()\n";
      return -1;
    }
    *pb = &dat_buf[0];
    remain = bufsize;
    while(remain>framesize && first_1pp==0){
      pmk5bh = Mk5B_Hdr_find(pb,remain,offset);
      pb+=offset; remain-=offset;
      if(pmk5bh ==0){ 
	cerr << " Error in Mk5B_Model::Get_FirstData(): Failed to find Mk5B-Header: Stopping...\n";
	return -1;
      }
      m5bhdr = *pmk5bh;
      if( m5bhdr.iFrame() ==0){	first_1pp=1; break;      }
      pb += framesize; remain -= framesize;
      continue;
    }
    if(!first_1pp) memmove(&dat_buf[0],pb,remain);
    
    // First data found!
  }

  memmove(&dat_buf[0],pb,remain);
  pb= &dat_buf[0]+remain;
  nrd = fread(pb,bufsize-remain,1,rfp);
  pb= &dat_buf[0];
  if(nrd>0){ remain = bufsize; }
  
  return remain;
}

int Mk5B_Model::Convert(const int ich, uint8_t *buf){
  
  

}
