/** Utility C++ Libraly
 * coded by 
 * @author M.Sekido 
 * @Version $Rev: 58 $
 * @Date  $Date: 2013-07-06 11:58:40 +0900 (Sat, 06 Jul 2013) $
 * $Id: utlty.hpp 58 2013-07-06 02:58:40Z vlbi $ 
 */

#ifndef __UTLTY__
#define __UTLTY__

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <vector>


long line_num( const char *file);
long euclid_gcm(const long a, const long b);
long arr_gcm(const double x[], int ndata);
// long arr_gcm(const float x[], int ndata);
double arr_mean(double x[], int ndata);
int arr_log10f(float *xarr, float *logarr, int n);

class Str1{
  char *buf;
  char *token[20];
  int nstr;
  int ntoken;
 public:
  Str1(void){
    nstr =0;
    buf ='\0';
  }
  Str1(char *str){
    nstr = strlen(str);
    buf  = new char [nstr+1];
    strcpy(buf,str);
  }
  ~Str1(){
    delete [] buf; 
  }
  int Ntoken(){ return(ntoken);}
  char** Token(){ return(token);}
  char* Token(int i ){ return(token[i]);}
  void Set_str(char *str){
    int nstr1 = strlen(str);
    if(nstr1 > nstr){
      nstr = nstr1;
      buf  = new char [nstr+1];
    }
    strcpy(buf,str);
  }
  void Resolve(char *del){
    char str1[nstr];
    strcpy(str1, buf);
    if((token[0] = strtok(str1, del)) == NULL) {
      ntoken =0; return;
    }else{
      int n;
      for(n=1; n<20 && (token[n] = strtok(NULL, del)) != NULL; n++);
      ntoken =n;
    }
    if (ntoken > 20){
      fprintf(stderr, "Error: Data format is wrong\n");
      fprintf(stderr, "line=%s \n", buf);
      exit(EXIT_FAILURE);
    }
    token[0] = strtok(buf, del);
    int i;
    for(i=1; i<ntoken; i++) token[i] = strtok(NULL, del);
    //    delete [] str1;
  }

};

// Rotating bar for waiting 
class Rot_bar{
  static char *str[4]; 
  const char *back;
  int ist;
 public:
  Rot_bar(void): back("\033[1D"),ist(0) {}
  //Rot_bar():ist(0),back("\033[1D") { };
  void Step(FILE *fp=stderr, char ini=0){ 
    if(ini != 0) putc(' ',fp); 
    fprintf(fp,"%s%s",back,str[ist % 4]); 
    ist++; }
};

template <typename T> 
inline std::vector <T> val2dB(std::vector <T>& arr){
  std::vector <T> retarr(arr.size());
  for(int i=0; i<(int)arr.size(); i++){
    retarr[i] = arr[i] > 0 ? 10*log10(arr[i]) : -INFINITY;
  }
  return retarr;
};



/** Template class for function object returning fractional value */
template <typename T> 
class frac:public unary_function <T,T>{
  T operator()(const T x)const{  return (T)fmod((double)x,1.0);  }
} ;

/** Template class for function object returning Log value */
template <typename T> 
struct Log:public unary_function <T,T>{
  T operator()(const T x)const{  return (T)( x>0 ? log((double)x) : -99);  }
} ;

template <typename T> 
class mult_x:public unary_function <T,T>{
  T y;
public:
  T operator()(const T x)const{  return (T)(x*y);  }
  void Set_cff(T a){y=a;}
} ;




// Parabolic Parameter updater

// class ParabUpdater{
//   double a,b,c;
//   double Mx, Mx2, Mx3, Mx4, Myx2, Myx, My;
//   double ndat;
//   double xoffst;
//   double yoffst;
//  public:
//   ParabUpdater(void){Initialize();};
//   void Initialize(void){ndat=0;Mx=Mx2=Mx3=Mx4=Myx2=Myx=My=0.; 
//   xoffst=0; yoffst=0;};
//   void FirstSet(const double *x, const double *y);
//   void Update(const double x, const double y);
//   const double X2Cff(void){return(a);}
//   const double X1Cff(void){return(b);}
//   const double X0Cff(void){return(c);}
//   const double Eval(const double x){ 
//     double x_norm = x - xoffst;
//     return ((a*x_norm+b)*x_norm + c + yoffst);
//   }
// };

// inline void ParabUpdater::Update(const double x, const double y){

//   double x_norm = x - xoffst;
//   double y_norm = y - yoffst;
//   Mx += x_norm;
//   double x2 = x_norm * x_norm;
//   Mx2 += x2;
//   Mx3 += x2*x_norm;
//   Mx4 += x2*x2;
//   Myx2 += y_norm*x2; 
//   Myx += y_norm*x_norm; 
//   My  += y_norm;
//   ndat +=1;

//   double C1 = Myx2 - My*Mx2/ndat;
//   double C2 = Myx - My*Mx/ndat;
//   double A1 = Mx4 - Mx2*Mx2/ndat;  
//   double A2 = Mx3 - Mx2*Mx/ndat;
//   double B2 = Mx2 - Mx*Mx/ndat;

//   a = (C1 * B2 - C2 * A2)/(A1*B2-A2*A2);
//   b = (C1-A1*a)/A2;
//   c = (My - Mx2*a - Mx *b)/ndat;
// }

// void inline ParabUpdater::FirstSet(const double *x, const double *y){

//   xoffst = x[0];
//   yoffst = y[0];
  
//   for(int i=0; i<3; i++){
//     double x_norm =x[i] - xoffst;
//     double y_norm =y[i] - yoffst;
//     double xtmp=1;
//     Mx += x_norm;
//     double x2 =x_norm*x_norm;
//     double x3 =x2*x_norm;
//     double x4 =x3*x_norm;
//     Mx2 += x2;
//     Mx3 += x3;
//     Mx4 += x4;
//     Myx2 += y_norm*x2;
//     Myx  += y_norm*x_norm;
//     My   += y_norm;
//   }
//   ndat=3;
  
//   double C1 = Myx2 - My*Mx2/ndat;
//   double C2 = Myx - My*Mx/ndat;
//   double A1 = Mx4 - Mx2*Mx2/ndat;  
//   double A2 = Mx3 - Mx2*Mx/ndat;
//   double B2 = Mx2 - Mx*Mx/ndat;

//   a = (C1 * B2 - C2 * A2)/(A1*B2-A2*A2);
//   b = (C1-A1*a)/A2;
//   c = (My - Mx2*a - Mx *b)/ndat;
// }


#endif
